var hidePopupTimeout = 0;
var dragging = false;

function stopp()
{
	player.controls.stop();
	player.style.visibility = "hidden";
}

function pplay()
{
	player.controls.play();
	player.style.visibility = "visible";
	
	if (document.body.style.height == "157px")
	{
		setMaxState();
	}
	else
	{
		setMinState();
	}
	
}

function nextt()
{
	player.controls.next();
}

function previous()
{
	player.controls.previous();
}
            
function ppause()
{
	player.controls.pause();
}

function onPopupTrClick()
{
	if (document.getElementById( "popup" ).style.visibility == "hidden")
		showPopup();
	else
		hidePopup();
}

function showPopup()
{
	var Popup = document.getElementById( "popup" );
	Popup.style.visibility = "visible";
	updateVolumeDisplay();
}

function hidePopup()
{
	var Popup = document.getElementById( "popup" );
	Popup.style.visibility = "hidden";
}

function Mute()
{
	var muted = System.Gadget.Settings.read("muted");
	if (muted == "false" || muted=="")
	{
		player.settings.mute = !player.settings.mute;
		
		System.Gadget.Settings.write("muted",  "true");
	} else
	{
		player.settings.mute = !player.settings.mute;
		
		System.Gadget.Settings.write("muted",  "false");
	}
	updateVolumeDisplay();
}

function getVolumeFromX( x )
{
	var volumePopup = document.getElementById("popup" );
	var volumeTrack = document.getElementById("volumeTrack");
	var volumeThumb = document.getElementById("volumeThumb");
	return Math.min( 1, Math.max( 0, (x - volumeTrack.offsetLeft - volumePopup.offsetLeft - 6) / (volumeTrack.offsetWidth - volumeThumb.offsetWidth) ) ) * 100;
}
            
function onVolTrackMove()
{
	if (window.event.button)
	{
		player.settings.volume = getVolumeFromX( window.event.clientX );
	}
	updateVolumeDisplay();
}

function updateVolumeDisplay()
{
	var volume = player.settings.volume;
	var volumeThumb = document.getElementById( "volumeThumb" );
	document.getElementById("volumeTrackFill").style.width = volume + "%";
	volumeThumb.style.left = Math.round( (volume * 0.01) * (volumeThumb.offsetParent.offsetWidth - volumeThumb.offsetWidth)) + "px";

	var volume = player.settings.volume;
                
	if (player.settings.mute)
	{
		volumeImg.src = "images/mute.png";
	}
	else if (volume == 0)
	{
		volumeImg.src = "images/mute.png";
	}
	else if (volume <= 33)
	{
		volumeImg.src = "images/vol_33.png";
	} else if (volume <= 66)
	{
		volumeImg.src = "images/vol_66.png";
	} else if (volume <= 99)
	{
		volumeImg.src = "images/vol_100.png";
	} else
	{
		volumeImg.src = "images/vol_100.png";
	}
}

function setHidePopupTimeout()
{
	if (hidePopupTimeout > 0) clearTimeout( hidePopupTimeout );
	hidePopupTimeout = setTimeout( onHidePopupTimeout, 1000 );
}
            
function clearHidePopupTimeout()
{
	if (hidePopupTimeout > 0) clearTimeout( hidePopupTimeout );
	hidePopupTimeout = 0;
}
            
function onHidePopupTimeout()
{
	hidePopup();
	hidePopupTimeout = 0;
}

function getTimeString( time )
{
	var hours = Math.floor( time / 3600 );
	var minutes = Math.floor( (time % 3600) / 60 );
	var seconds = Math.floor( time % 60 );
	var timeString = "";
	if (time >= 3600) timeString = hours + ":";
	timeString += (hours > 0 && minutes < 10 ? "0" : "" ) + minutes + ":" + (seconds < 10 ? "0" : "" ) + seconds;
                
 	return timeString;
}

function setTrackPercent( percent )
{
	trackFill.style.width = Math.round( percent * 100 ) + "%";
	mediaTime.innerHTML = 
		getTimeString( Math.round( player.currentMedia.duration * percent ) ) + " / " +
		getTimeString( player.currentMedia.duration );
}
            
function updateTime()
{
	if (dragging) return;
	var trackFill = document.getElementById("trackFill");
	var mediaTime = document.getElementById("mediaTime");
                
	var percent = 0;
	if (player.currentMedia)
	{
		mediaTime.innerHTML = 
			getTimeString( player.controls.currentPosition ) + " / " +
			getTimeString( player.currentMedia.duration );
			
		percent = player.controls.currentPosition / player.currentMedia.duration;
	}
	else
	{
		mediaTime.innerHTML = "";

	}
                
	if (!dragging)
	{
		setTrackPercent( percent );
	}
	setTimeout(updateTime,1000);
}

function getPercentFromX( x )
{
	var track = document.getElementById("track");
	return Math.min( 1, Math.max( 0, (x - track.offsetLeft) / (track.offsetWidth) ) );
}
            
function onTrackUp()
{
	dragging = false;
	player.controls.currentPosition = getPercentFromX( window.event.clientX ) * player.currentMedia.duration;
	updateTime();
}

function getAuthorString( media )
{
	var authorCount = media.getAttributeCountByType( "Author", "" );
	var authorString = "";
	for (var i = 0; i < authorCount; i++)
	{
		authorString += media.getItemInfoByType( "Author", "", i );
		if (i + 1 < authorCount) authorString += ";";
	}
	return authorString;
}

function infoHide()
{
	var mediaArtist = document.getElementById( "mediaArtist" );
	var mediaGenre = document.getElementById ( "mediaGenre" );
	var mediaYear = document.getElementById ( "mediaYear" );
	var mediaName = document.getElementById ( "mediaName" );
	var mediaTime = document.getElementById ( "mediaTime");
	var mediaAlbum = document.getElementById ( "mediaAlbum" );
	
	mediaArtist.style.visibility = "hidden";
	mediaGenre.style.visibility = "hidden";
	mediaYear.style.visibility = "hidden";
	mediaName.style.visibility = "hidden";
	mediaTime.style.visibility = "hidden";
	mediaAlbum.style.visibility = "hidden";
}

function infoShow()
{
	var mediaArtist = document.getElementById( "mediaArtist" );
	var mediaGenre = document.getElementById ( "mediaGenre" );
	var mediaYear = document.getElementById ( "mediaYear" );
	var mediaName = document.getElementById ( "mediaName" );
	var mediaTime = document.getElementById ( "mediaTime");
	var mediaAlbum = document.getElementById ( "mediaAlbum" );
	
	mediaArtist.style.visibility = "visible";
	mediaGenre.style.visibility = "visible";
	mediaYear.style.visibility = "visible";
	mediaName.style.visibility = "visible";
	mediaTime.style.visibility = "visible";
	mediaAlbum.style.visibility = "visible";
}

function openPlaylist()
{
	System.Gadget.Flyout.show = !System.Gadget.Flyout.show;
}

function DragNDrop()
{
    var intIndex = 0;
    var oItem;
    var sItem;
    while(oItem = System.Shell.itemFromFileDrop(event.dataTransfer, intIndex))
    {
        // Display object properties and increment the index.
        if (oItem.isFileSystem == true)
        {
            sItem = oItem.path;
		
		document.player.URL = sItem;
		
        intIndex++;
		
        }
        else
        {
            return;
        }
    }
	

	pplay();
	BTP.style.visibility = "visible";

}

function setMaxState()
{
   with(document.body.style)
        width=130,
        height=157;
		
    with(backgr.style)
        width=130,
        height=157;
	backgr.src = "url(images/back.png)";
	
    with(glass.style)
		visibility = "visible";

    with(player.style)
		height = 110;

    with(albumArt.style)
		height=110;
		
	with(controls.style)
		top=0;
		
	with(track.style)
		top=118;
	with(popup.style)
		top=112;
	with(Max.style)
		visibility = "hidden";
	with(Min.style)
		visibility = "visible";
	with(nowPlaying.style)
		visibility = "hidden";
}

function setMinState()
{
    with(document.body.style)
        width=130,
        height=58;
		
    with(backgr.style)
        width=130,
        height=58;
	backgr.src = "url(images/body_min.png)";
	
    with(glass.style)
		visibility = "hidden";

    with(player.style)
		height = 0;
		
	with(controls.style)
		top=-99;

    with(albumArt.style)
		height=0;
	with(popup.style)
		top=14;
	with(track.style)
		top=18;
	with(Min.style)
		visibiliti = "hidden";
	with(Max.style)
		visibility = "visible";
	with(nowPlaying.style)
		visibility = "visible";
		
	updateNowPlaying();
}

function updateNowPlaying()
{
	var nowPlayingText = "<marquee width ='114' scrolldelay ='80' scrollamount ='2'><div id='nowPlayingText'><b>" + mName + minName.innerHTML + mArtist + minArtist.innerHTML + mAlbum + minAlbum.innerHTML + "</b></div></marquee>";
	nowPlaying.innerHTML = nowPlayingText;
}

function ScrollMediaName()
{
	var mediaNameText = "<marquee width ='114' scrolldelay ='80' scrollamount ='2'><div id='mediaNameText'><b>" + minName.innerHTML + "</b></div></marquee>";
	mediaName.innerHTML = mediaNameText;
}

function ScrollMediaArtist()
{
	var mediaArtistText = "<marquee width ='114' scrolldelay ='80' scrollamount ='2'><div id='mediaArtistText'><b>" + minArtist.innerHTML + "</b></div></marquee>";
	mediaArtist.innerHTML = mediaArtistText;
}

function goPP()
{
	onLoad();
	pplay();
}